;#macro exportRoutine(routineName, routineExportName, page)
;	.echo >>	micros.inc	routineExportName, " .equ ", convhex($ & 3FFFh | page), "\n"
;	jp	routineName
;#endmacro
#define exportedRoutinesCount 0
; This macro generates macros. . . .
#ifdef REGENERATE_DOCUMENTATION
;	.echo >> 	exporttemp	"sys", routineExportName, "\t.equ\t(", routineExportName," & 3FFFh | ", page, ")\n"
#macro exportRoutine(routineExportName, page)
	.echo >> 	exporttemp	"#define sys", routineExportName, "\teval(", routineExportName," & 3FFFh | ", page, ")\n"
	.echo >>	exporttemp	".echo >>\tmicros.inc\t\"", routineExportName, "\t.equ\t\", convhex($ & 3FFFh | ", page, "), \"\\n\"\n"
	.echo >>	exporttemp	"\tjp\t", routineExportName, "\n"
	#define exportedRoutinesCount eval(exportedRoutinesCount + 1)
#endmacro
#macro microsInc(text)
	.echo >>	exporttemp	".echo >>\tmicros.inc\t\"", text, "\\n\"\n"
#endmacro
#else
#macro exportRoutine(routineExportName, page)
	.echo >> 	exporttemp	"#define sys", routineExportName, "\teval(", routineExportName," & 3FFFh | ", page, ")\n"
	.echo >>	exporttemp	"\tjp\t", routineExportName, "\n"
	#define exportedRoutinesCount eval(exportedRoutinesCount + 1)
#endmacro
#macro microsInc(text)
	; Do nothing.
#endmacro
#endif

first_jump_table_entry_point:
#ifdef REGENERATE_DOCUMENTATION
.echo >	micros.inc	"; MICROS SYSTEM ROUTINES & EQUATES\n"
.echo >>	micros.inc	"\n;------ RAM Addresses ----------------------------------------------------------\n"
.echo >>	micros.inc	"microsRamCode	.equ	", convhex(microsRamCode), "\n"
.echo >>	micros.inc	"microsBasePage	.equ	", convhex(microsBasePage), "\n"
.echo >>	micros.inc	"\n\n;------ Macros -----------------------------------------------------------------\n"
.echo >>	micros.inc	"#macro syscall(routine)\n"
.echo >>	micros.inc	"	ld	iy, routine\n"
.echo >>	micros.inc	"	call	SysCallRoutine\n"
.echo >>	micros.inc	"#endmacro\n"
.echo >>	micros.inc	"#macro syscallcc(cc, routine)\n"
.echo >>	micros.inc	"	ld	iy, routine\n"
.echo >>	micros.inc	"	call	cc, SysCallRoutine\n"
.echo >>	micros.inc	"#endmacro\n"
.echo >>	micros.inc	"; Total overhead to save and restore interrupts:\n"
.echo >>	micros.inc	"; 11 bytes and 77 clock cycles (unless you use the restore alternative macros)\n"
.echo >>	micros.inc	"#macro pushAndDisableInterrupts\n"
.echo >>	micros.inc	"	ld	a, i\n"
.echo >>	micros.inc	"	push	af\n"
.echo >>	micros.inc	"	di\n"
.echo >>	micros.inc	"#endmacro\n"
.echo >>	micros.inc	"#macro popAndRestoreInterrupts\n"
.echo >>	micros.inc	"	pop	af\n"
.echo >>	micros.inc	"	jp	po, $+4\n"
.echo >>	micros.inc	"	ei\n"
.echo >>	micros.inc	"#endmacro\n"
.echo >>	micros.inc	"#macro popAndRestoreInterruptsRelocatable\n"
.echo >>	micros.inc	"	ex	(sp), hl\n"
.echo >>	micros.inc	"	bit	2, l\n"
.echo >>	micros.inc	"	pop	hl\n"
.echo >>	micros.inc	"	jr	z, $+3\n"
.echo >>	micros.inc	"	ei\n"
.echo >>	micros.inc	"#endmacro\n"
.echo >>	micros.inc	"#macro popAndRestoreInterruptsSaveA\n"
.echo >>	micros.inc	"	ex	(sp), hl\n"
.echo >>	micros.inc	"	bit	2, l\n"
.echo >>	micros.inc	"	pop	hl\n"
.echo >>	micros.inc	"	jr	z, $+3\n"
.echo >>	micros.inc	"	ei\n"
.echo >>	micros.inc	"#endmacro\n"
.echo >>	micros.inc	"#macro pushPageA\n"
.echo >>	micros.inc	"	in	a, (14)\n"
.echo >>	micros.inc	"	rra\n"
.echo >>	micros.inc	"	in	a, (6)\n"
.echo >>	micros.inc	"	push	af\n"
.echo >>	micros.inc	"#endmacro\n"
.echo >>	micros.inc	"#macro popPageA\n"
.echo >>	micros.inc	"	pop	af\n"
.echo >>	micros.inc	"	out	(6), a\n"
.echo >>	micros.inc	"	sbc	a, a\n"
.echo >>	micros.inc	"	out	(14), a\n"
.echo >>	micros.inc	"#endmacro\n"
.echo >>	micros.inc	"\n\n;------ RAM-resident Routines --------------------------------------------------\n"
.echo >>	micros.inc	"SysCallRoutine	.equ	", convhex(SysCallRoutine), "\n"
.echo >>	micros.inc	"SysJumpRoutine	.equ	", convhex(SysJumpRoutine), "\n"
.echo >>	micros.inc	"PagedCall	.equ	", convhex(PagedCall), "\n"
.echo >>	micros.inc	"PagedJump	.equ	", convhex(PagedJump), "\n"
.echo >>	micros.inc	"LdDEHLInd	.equ	", convhex(LdDEHLInd), "\n"
.echo >>	micros.inc	"MultHByE	.equ	", convhex(MultHByE), "\n"
.echo >>	micros.inc	"PutByte	.equ	", convhex(PutByte), "\n"
.echo >>	micros.inc	"GetByte	.equ	", convhex(GetByte), "\n"
.echo >>	micros.inc	"SubPtr	.equ	", convhex(SubPtr), "\n"
.echo >>	micros.inc	"AddPtr	.equ	", convhex(AddPtr), "\n"
.echo >>	micros.inc	"DecPtr	.equ	", convhex(DecPtr), "\n"
.echo >>	micros.inc	"IncPtr	.equ	", convhex(IncPtr), "\n"
.echo >>	micros.inc	"GetByteIncPtr .equ ", convhex(GetByteIncPtr), "\n"
.echo >>	micros.inc	"\n\n;------ Page 0 -----------------------------------------------------------------\n"
#endif
;#comment
.echo >	exporttemp	""
microsInc("\n; Init/exit")
exportRoutine("StartMicrOS", syscallPage0)
exportRoutine("RebootMicrOS", syscallPage0)
exportRoutine("GetVersion", syscallPage0)
exportRoutine("MainMenu", syscallPage0)
exportRoutine("RebootDevice", syscallPage0)
exportRoutine("MicrosApd", syscallPage0)
microsInc("\n; Utility")
;exportRoutine("MultHByE", syscallPage0)
exportRoutine("DispByte", syscallPage0)
exportRoutine("DispHL", syscallPage0)
exportRoutine("DispDecimal", syscallPage0)
exportRoutine("ClearMem", syscallPage0)
exportRoutine("ProcessKeyJumpTable", syscallPage0)
exportRoutine("Menu", syscallPage0)
exportRoutine("AnyKey", syscallPage0)
exportRoutine("Panic", syscallPage0)
microsInc("\n; System")
exportRoutine("InitRamRoutines", syscallPage0)
microsInc("\n; Interrupts")
exportRoutine("ApdOn", syscallPage0)
exportRoutine("ApdOff", syscallPage0)
exportRoutine("SetUpInterrupts", syscallPage0)
microsInc("\n; Memory")
exportRoutine("CompactPageNumber", syscallPage0)
exportRoutine("ExpandPageNumber", syscallPage0)
;exportRoutine("IncPtrSource", syscallPage0)
;exportRoutine("DecPtrSource", syscallPage0)
;exportRoutine("AddPtrSource", syscallPage0)
;exportRoutine("SubPtrSource", syscallPage0)
;exportRoutine("GetByteSource", syscallPage0)
;exportRoutine("PutByteSource", syscallPage0)
microsInc("; FYI, these routines are copied to RAM before execution.")
microsInc("; After the first call, the last such routine executed remains in microsRamCode,")
microsInc("; so you can call the routine again faster by just directly calling microsRamCode.")
exportRoutine("BlockCopy", syscallPage0)
exportRoutine("WriteFlashByte", syscallPage0)
exportRoutine("EraseSector", syscallPage0)
exportRoutine("IssueAutoSelect", syscallPage0)
	; Archive
	;  - To do
microsInc("\n; Keyboard")
exportRoutine("GetAscii", syscallPage0)
exportRoutine("ClearShiftFlags", syscallPage0)
exportRoutine("ClearAllShiftFlags", syscallPage0)
exportRoutine("GetKeyShifts", syscallPage0)
exportRoutine("GetHexByte", syscallPage0)
exportRoutine("GetKey", syscallPage0)
exportRoutine("CursorOn", syscallPage0)
exportRoutine("CursorOff", syscallPage0)
exportRoutine("GetCSC", syscallPage0)
exportRoutine("PeekCSC", syscallPage0)
exportRoutine("ScanKeyboard", syscallPage0)
exportRoutine("RawGetCSC", syscallPage0)
microsInc("\n; LCD")
exportRoutine("ExecScrnScriptUi", syscallPage0)
exportRoutine("BacklightOff", syscallPage0)
exportRoutine("BacklightUp", syscallPage0)
exportRoutine("BacklightSetLevel", syscallPage0)
exportRoutine("BacklightOn", syscallPage0)
exportRoutine("BacklightDown", syscallPage0)
exportRoutine("LcdOff", syscallPage0)
exportRoutine("LcdInit", syscallPage0)
exportRoutine("ClrScrnFull", syscallPage0)
exportRoutine("FillScrnFull", syscallPage0)
microsInc("\n; Screen")
exportRoutine("ScrollUp", syscallPage0)
exportRoutine("SetFullScrnWind", syscallPage0)
exportRoutine("ClearWind", syscallPage0)
exportRoutine("PutSClrWind", syscallPage0)
exportRoutine("PutS", syscallPage0)
exportRoutine("Locate", syscallPage0)
exportRoutine("HomeUp", syscallPage0)
exportRoutine("CursorBack", syscallPage0)
exportRoutine("CursorForward", syscallPage0)
exportRoutine("CursorRight", syscallPage0)
exportRoutine("CursorLeft", syscallPage0)
exportRoutine("CursorDown", syscallPage0)
exportRoutine("CursorUp", syscallPage0)
exportRoutine("AdvanceCursor", syscallPage0)
exportRoutine("NewLine", syscallPage0)
exportRoutine("NewLineClrEOL", syscallPage0)
exportRoutine("NewLine2", syscallPage0)
exportRoutine("NewLineClrEOL2", syscallPage0)
exportRoutine("NextTab", syscallPage0)
exportRoutine("PutSpace", syscallPage0)
exportRoutine("PutSpaces", syscallPage0)
exportRoutine("PutC2", syscallPage0)
exportRoutine("PutC", syscallPage0)
exportRoutine("ReadChar", syscallPage0)
exportRoutine("ResetScreen", syscallPage0)
exportRoutine("FixCursor", syscallPage0)
exportRoutine("SetCharRow", syscallPage0)
exportRoutine("SetCharCol", syscallPage0)
exportRoutine("SetLcdWindowColumnBounds", syscallPage0)
exportRoutine("SetDirectionRight", syscallPage0)
exportRoutine("SetDirectionDown", syscallPage0)
	; To do: Add linking routines
;#endcomment
#include "exporttemp"
last_jump_table_entry_point:
